TT_MSG_VERSION = GetAddOnMetadata("Tabard Tell","Version");
TT_MSG_ADDONNAME = "Tabard Tell";

-- Colours
COLOR_RED = "|cffff0000";
COLOR_GREEN = "|cff00ff00";
COLOR_BLUE = "|cff0000ff";
COLOR_PURPLE = "|cff700090";
COLOR_YELLOW = "|cffffff00";
COLOR_ORANGE = "|cffff6d00";
COLOR_GREY = "|cff808080";
COLOR_GOLD = "|cffcfb52b";
COLOR_NEON_BLUE = "|cff4d4dff";
COLOR_END = "|r";

TT = {};

function TT.OnLoad()
	GameTooltip:HookScript("OnTooltipSetItem", TT.HookSetItem);
	TT.TABARD_EQUIP_FILTER = "Equip:";
	TT.TABARD_FACTION_FILTER = "the cause of [the ]*([^\.]+)\.";
	
	TT.lines = {5,7};  -- lines of the tooltip to examine
end

function TT.GetEquipTextFromToolTip()
	for _,i in pairs(TT.lines) do
		TT.text = getglobal("GameTooltipTextLeft"..i):GetText();
		if TT.text and strfind(TT.text, TT.TABARD_EQUIP_FILTER) then
			return TT.text;
		end
	end
end

function TT.HookSetItem(...)
	TT.item = GameTooltip:GetItem();
	TT.slot = select(9,GetItemInfo(TT.item));
	if TT.slot == "INVTYPE_TABARD" then
		TT.itemEquip = TT.GetEquipTextFromToolTip();
		if TT.itemEquip then
			_, _, TT.faction = strfind(TT.itemEquip, TT.TABARD_FACTION_FILTER);
			
			if TT.faction then
				_, _, TT.standing, _, TT.topVal, TT.currentVal = TT.GetFactionInfo( TT.faction );
				TT.factionString = string.format("\n%s %s / %s (%0.2f%%)",
						TT.standing, TT.currentVal, TT.topVal, (TT.currentVal / TT.topVal) * 100);
				GameTooltip:AddLine(TT.factionString);
			end
		end
	end
end

-- return a list of faction info
function TT.GetFactionInfo( factionNameIn )
	for factionIndex = 1, GetNumFactions() do
		TT.fName, TT.fDescription, TT.fStandingId, TT.fBottomValue, TT.fTopValue, TT.fEarnedValue, TT.fAtWarWith,
				TT.fCanToggleAtWar, TT.fIsHeader, TT.fIsCollapsed, TT.fIsWatched = GetFactionInfo(factionIndex);
		TT.fBarBottomValue = 0;
		TT.fBarTopValue = TT.fTopValue - TT.fBottomValue;
		TT.fBarEarnedValue = TT.fEarnedValue - TT.fBottomValue;
		TT.fStandingStr = getglobal("FACTION_STANDING_LABEL"..TT.fStandingId);
		
		if not TT.fIsHeader and strfind(TT.fName, factionNameIn) then
			return TT.fName, TT.fDescription, TT.fStandingStr, TT.fBarBottomValue, TT.fBarTopValue, TT.fBarEarnedValue, 
					TT.fAtWarWith, TT.fCanToggleAtWar, TT.fIsHeader, TT.fIsCollapsed, TT.fIsWatched, factionIndex;
		end
	end
end
